drop   type PERSON_typ force
/
create type PERSON_typ as object (
person_id            number,
last_name            varchar2(30),
first_name           varchar2(30),
middle_name          varchar2(30),
birth_date           date,
mothers_maiden_name  varchar2(30),
identifiers          person_identifier_tab, 
map member function get_map return varchar2,
member function get_age return number,
member function get_age_on( aid_date in date ) return number,
static function get_id  return number );
/
create type body PERSON_typ as
map member function get_map return varchar2 is
begin
 return rpad( last_name, 30 )||
        rpad( first_name, 30 )||
        rpad( middle_name, 30 )||
        rpad( mothers_maiden_name,30 )||
        to_char( birth_date, 'YYYYMMDDHH24MISS' );
end get_map;

member function get_age return number is
begin
 return trunc( months_between( SYSDATE, birth_date ) / 12 );
end get_age; 

member function get_age_on( aid_date in date ) return number is
begin
 return trunc( months_between( aid_date, birth_date ) / 12 );
end get_age_on; 

static function get_id  return number is
n_person_id number := 0;
begin
 select person_seq.nextval into n_person_id from dual;
 return n_person_id;
end get_id;

end;
/
