import java.sql.SQLException;
import oracle.jdbc.driver.OracleConnection;
import oracle.jdbc.driver.OracleTypes;
import java.sql.SQLData;
import java.sql.SQLInput;
import java.sql.SQLOutput;
import oracle.sql.STRUCT;
import oracle.jpub.runtime.MutableStruct;

public class PersonLocation implements SQLData
{
  public static final String _SQL_NAME = "SCOTT.PERSON_LOCATION_TYP";
  public static final int _SQL_TYPECODE = OracleTypes.STRUCT;

  private java.math.BigDecimal m_personId;
  private java.math.BigDecimal m_locationId;
  private java.sql.Timestamp m_startDate;
  private java.sql.Timestamp m_endDate;

  /* constructor */
  public PersonLocation()
  {
  }

  public void readSQL(SQLInput stream, String type)
  throws SQLException
  {
      setPersonId(stream.readBigDecimal());
      setLocationId(stream.readBigDecimal());
      setStartDate(stream.readTimestamp());
      setEndDate(stream.readTimestamp());
  }

  public void writeSQL(SQLOutput stream)
  throws SQLException
  {
      stream.writeBigDecimal(getPersonId());
      stream.writeBigDecimal(getLocationId());
      stream.writeTimestamp(getStartDate());
      stream.writeTimestamp(getEndDate());
  }

  public String getSQLTypeName() throws SQLException
  {
    return _SQL_NAME;
  }

  /* accessor methods */
  public java.math.BigDecimal getPersonId()
  { return m_personId; }

  public void setPersonId(java.math.BigDecimal personId)
  { m_personId = personId; }


  public java.math.BigDecimal getLocationId()
  { return m_locationId; }

  public void setLocationId(java.math.BigDecimal locationId)
  { m_locationId = locationId; }


  public java.sql.Timestamp getStartDate()
  { return m_startDate; }

  public void setStartDate(java.sql.Timestamp startDate)
  { m_startDate = startDate; }


  public java.sql.Timestamp getEndDate()
  { return m_endDate; }

  public void setEndDate(java.sql.Timestamp endDate)
  { m_endDate = endDate; }

}
